//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.plugin.html.guimodel;

import de.ugoe.cs.autoquest.eventcore.guimodel.IFrame;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @author Patrick Harms
 */
public class HTMLServer extends HTMLGUIElement implements IFrame {

    /**  */
    private static final long serialVersionUID = 1L;

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @param specification
     * @param parent
     */
    public HTMLServer(HTMLServerSpec specification, HTMLGUIElement parent) {
        super(specification, null);
        
        if (parent != null) {
            throw new IllegalArgumentException("a GUI element representing the server must not " +
                                               "have a parent GUI element");
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        String str = "Server(" + getHost();

        if (getPort() > -1 ) {
            str += ":" + getPort();
        }
        
        str += ")";
        return str;
    }

    /*
     * (non-Javadoc)
     * 
     * @see de.ugoe.cs.autoquest.plugin.html.guimodel.HTMLGUIElement#getElementDescriptor()
     */
    @Override
    protected String getElementDescriptor() {
        return "Server";
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @return
     */
    public String getHost() {
        return ((HTMLServerSpec) super.getSpecification()).getHost();
    }

    /**
     * <p>
     * TODO: comment
     * </p>
     *
     * @return
     */
    public int getPort() {
        return ((HTMLServerSpec) super.getSpecification()).getPort();
    }

}
